Bug 62350 - [Chromium] Forward shift + up/down key events to text field when autofill popup window is shown.
Summary: [Chromium] Forward shift + up/down key events to text field when autofill pop...
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: New Bugs (show other bugs)
Version: 528+ (Nightly build)
Hardware: Unspecified Unspecified
: P2 Normal
Assignee: Naoki Takano
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2011-06-08 20:31 PDT by Naoki Takano
Modified: 2011-06-14 19:10 PDT (History)
8 users (show)

See Also:


Attachments
Patch (3.34 KB, patch)
2011-06-08 21:08 PDT, Naoki Takano
no flags Details | Formatted Diff | Diff
Patch (3.43 KB, patch)
2011-06-13 22:56 PDT, Naoki Takano
no flags Details | Formatted Diff | Diff
Patch (3.46 KB, patch)
2011-06-14 18:22 PDT, Naoki Takano
no flags Details | Formatted Diff | Diff
Patch (3.48 KB, patch)
2011-06-14 18:54 PDT, Naoki Takano
no flags Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Naoki Takano 2011-06-08 20:31:09 PDT
[Chromium] Forward shit + up/down key events to text field when autofill popup window is shown.
Comment 1 Naoki Takano 2011-06-08 21:08:14 PDT
Created attachment 96540 [details]
Patch
Comment 2 Naoki Takano 2011-06-08 21:13:40 PDT
Please review my patch.
Comment 3 Kent Tamura 2011-06-08 21:31:42 PDT
Comment on attachment 96540 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=96540&action=review

> Source/WebCore/ChangeLog:5
> +        [Chromium] Forward shit + up/down key events to text field when autofill popup window is shown.

Why do we forward only these specific key combinations?  No need to forward other keys?
What about Command+cursor on Mac?
Comment 4 Naoki Takano 2011-06-08 21:47:37 PDT
Kent-san,

Thank you for your review.

Original bug report only refers to "shift + up". (I typo "shit" though, orz)

Is there any other combination I have to consider?
If shift/control/alt/command keys are appended, do I have to forward all up/down key events?

(In reply to comment #3)
> (From update of attachment 96540 [details])
> View in context: https://bugs.webkit.org/attachment.cgi?id=96540&action=review
> 
> > Source/WebCore/ChangeLog:5
> > +        [Chromium] Forward shit + up/down key events to text field when autofill popup window is shown.
> 
> Why do we forward only these specific key combinations?  No need to forward other keys?
> What about Command+cursor on Mac?
Comment 5 Kent Tamura 2011-06-08 22:45:42 PDT
(In reply to comment #4)
> Kent-san,
> 
> Thank you for your review.
> 
> Original bug report only refers to "shift + up". (I typo "shit" though, orz)
> 
> Is there any other combination I have to consider?
> If shift/control/alt/command keys are appended, do I have to forward all up/down key events?

I don't know.  You should discuss it with Autofill team and Chrome UX team.
Comment 6 Naoki Takano 2011-06-08 22:47:47 PDT
I know Autofill team, David and Ilya. Actually I already added Ilya here.

But I don't know who are in Chrome UX team.

Do you know them?

Thanks,

(In reply to comment #5)
> (In reply to comment #4)
> > Kent-san,
> > 
> > Thank you for your review.
> > 
> > Original bug report only refers to "shift + up". (I typo "shit" though, orz)
> > 
> > Is there any other combination I have to consider?
> > If shift/control/alt/command keys are appended, do I have to forward all up/down key events?
> 
> I don't know.  You should discuss it with Autofill team and Chrome UX team.
Comment 7 Ilya Sherman 2011-06-08 23:07:56 PDT
(In reply to comment #4)
> Kent-san,
> 
> Thank you for your review.
> 
> Original bug report only refers to "shift + up". (I typo "shit" though, orz)
> 
> Is there any other combination I have to consider?
> If shift/control/alt/command keys are appended, do I have to forward all up/down key events?
> 
> (In reply to comment #3)
> > (From update of attachment 96540 [details] [details])
> > View in context: https://bugs.webkit.org/attachment.cgi?id=96540&action=review
> > 
> > > Source/WebCore/ChangeLog:5
> > > +        [Chromium] Forward shit + up/down key events to text field when autofill popup window is shown.
> > 
> > Why do we forward only these specific key combinations?  No need to forward other keys?
> > What about Command+cursor on Mac?

If we want to be absolutely perfect, we should probably forward more key combinations.  For example, on Mac, option-up/down should move the cursor without selecting text.  On the other hand, the ideal behavior for ctrl-up/down is to jump to the top/bottom of the popup list.  That's on Mac -- I'm not as sure what the behavior should be on the other platforms.

That said, I am fine with forwarding either only key combinations involving shift, as shift-up/down is by far the most common cursor movement of this sort.  I am also fine with forwarding all key presses with modifiers, and only intercepting literal up/down arrow presses.

David, Glen, any thoughts to add into the mix?
Comment 8 Naoki Takano 2011-06-09 18:12:12 PDT
David and Glen,

Could you give us your thoughts?

Thanks,

(In reply to comment #7)
> (In reply to comment #4)
> > Kent-san,
> > 
> > Thank you for your review.
> > 
> > Original bug report only refers to "shift + up". (I typo "shit" though, orz)
> > 
> > Is there any other combination I have to consider?
> > If shift/control/alt/command keys are appended, do I have to forward all up/down key events?
> > 
> > (In reply to comment #3)
> > > (From update of attachment 96540 [details] [details] [details])
> > > View in context: https://bugs.webkit.org/attachment.cgi?id=96540&action=review
> > > 
> > > > Source/WebCore/ChangeLog:5
> > > > +        [Chromium] Forward shit + up/down key events to text field when autofill popup window is shown.
> > > 
> > > Why do we forward only these specific key combinations?  No need to forward other keys?
> > > What about Command+cursor on Mac?
> 
> If we want to be absolutely perfect, we should probably forward more key combinations.  For example, on Mac, option-up/down should move the cursor without selecting text.  On the other hand, the ideal behavior for ctrl-up/down is to jump to the top/bottom of the popup list.  That's on Mac -- I'm not as sure what the behavior should be on the other platforms.
> 
> That said, I am fine with forwarding either only key combinations involving shift, as shift-up/down is by far the most common cursor movement of this sort.  I am also fine with forwarding all key presses with modifiers, and only intercepting literal up/down arrow presses.
> 
> David, Glen, any thoughts to add into the mix?
Comment 9 Glen Murphy 2011-06-09 19:58:30 PDT
Ilya's proposal of forwarding all keypresses with modifiers sounds good to me.
Comment 10 David Holloway 2011-06-10 08:47:22 PDT
(In reply to comment #9)
> Ilya's proposal of forwarding all keypresses with modifiers sounds good to me.

Yes, sounds good to me.
Comment 11 Naoki Takano 2011-06-10 09:53:24 PDT
Thanks, guys.

I'll do that.

(In reply to comment #10)
> (In reply to comment #9)
> > Ilya's proposal of forwarding all keypresses with modifiers sounds good to me.
> 
> Yes, sounds good to me.
Comment 12 Naoki Takano 2011-06-13 22:56:36 PDT
Created attachment 97071 [details]
Patch
Comment 13 Kent Tamura 2011-06-13 23:12:07 PDT
Comment on attachment 97071 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=97071&action=review

> Source/WebCore/ChangeLog:11
> +        * manual-tests/autofill-popup-shiftupdown.hml: Added to check modifier + up/down key is working correctly for text area in autofill popup is shown.

This test is Chromium-specific.  It should be put to WebCore/manual-tests/chromium/.
Comment 14 Naoki Takano 2011-06-14 18:22:41 PDT
Created attachment 97211 [details]
Patch
Comment 15 Kent Tamura 2011-06-14 18:23:58 PDT
Comment on attachment 97211 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=97211&action=review

> Source/WebCore/ChangeLog:11
> +        Manual test: autofill-popup-shiftupdown.html
> +
> +        * manual-tests/autofill-popup-shiftupdown.hml: Added to check modifier + up/down key is working correctly for text area in autofill popup is shown.

Need to update ChangeLog
Comment 16 Naoki Takano 2011-06-14 18:54:04 PDT
Created attachment 97219 [details]
Patch
Comment 17 Kent Tamura 2011-06-14 19:01:31 PDT
Comment on attachment 97219 [details]
Patch

Looks ok.
Comment 18 Naoki Takano 2011-06-14 19:09:39 PDT
Thank, kent-san!!

(In reply to comment #17)
> (From update of attachment 97219 [details])
> Looks ok.
Comment 19 WebKit Review Bot 2011-06-14 19:10:45 PDT
Comment on attachment 97219 [details]
Patch

Clearing flags on attachment: 97219

Committed r88895: <http://trac.webkit.org/changeset/88895>
Comment 20 WebKit Review Bot 2011-06-14 19:10:50 PDT
All reviewed patches have been landed.  Closing bug.